addLoadListener(init);

var BPM = 100;
var clockCount = 0;
var CANVAS_WIDTH = 540;
var CANVAS_HEIGHT = 480;
var canvasDOM = [];
var neverStarted = true;
var canPlaySound = true;

var sounds = 
{
	kick1:
	{
		file: "707__vitriolix__subbasesoft.wav"
	},
	snare1:
	{
		file: "TicTacShutUp_prac_snare_2.wav"
	},
	hatOpen1: 
	{
		file: "41945__datasoundsample__maypex_OHH.wav"
	},
	hatClose1: 
	{
		file: "61555__Robinhood76__aa084_Sabian_AAX_hihat_14_closed_weak.wav"
	},
	clap1: 
	{
		file: "2080__opm__CP_set1.wav"
	},
	bongo1:
	{
		file: "28706__teleport8__bongohigh1.wav"
	},
	bongo2: 
	{
		file: "28707__teleport8__bongohigh2.wav"
	},
	work1: 
	{
		file: "work2.wav"
	}
};




function init()
{

/*
	for (var sound in sounds)
	{
		var embedContainer = document.createElement("div");
		embedContainer.className = "embedContainer";
		document.body.appendChild(embedContainer);
		embedContainer.innerHTML = soundElementString(sound, sounds[sound]);
	}
*/
	var samples = document.getElementById("samples");
	var tds = samples.getElementsByTagName("td");
	
	for (var i = 0; i < tds.length; i++)
	{
	
	attachEventListener(tds[i], "mousedown", toggleSample, false);

		if (Math.floor(i / 3) % 2 > 0)
		{
			tds[i].className += " col";
		}
	}
	
	var trs = samples.getElementsByTagName("tr");
	
	for (var i = 0; i < trs.length; i++)
	{
		if (i % 2 > 0)
		{
			trs[i].className = "odd";
		}
	}
	
	var play = document.getElementById("play_drum");
	attachEventListener(play, "click", togglePlay, false);

	var visualise = document.getElementById("visualise");
	attachEventListener(visualise, "click", toggleVisualisation, false);
}




function togglePlay(event)
{
	neverStarted = false;
	
	if (this.className == "on")
	{
		this.className = "";
		
		stopClock();
	}
	else
	{
		this.className = "on";
		
		clock();
	}
	
	this.blur();
	
	if (typeof event != "undefined")
	{
		stopDefaultAction(event);
	}
	
	return false;
}




function toggleVisualisation()
{
	var visualise = document.getElementById("visualise");
	
	if (visualise.className == "on")
	{
		visualise.className = "";

		var canvas = document.getElementById("visuals");
		
		if (canvas != null)
		{
			canvas.parentNode.removeChild(canvas);
		}
		
		var mask = document.getElementById("mask");
		
		if (mask != null)
		{
			tween(mask, {height: 0}, 600);
		}
	}
	else
	{
		if (typeof document.all == "undefined")
		{
			visualise.className = "on";
			
			var mask = document.getElementById("mask");
			
			if (mask == null)
			{
				mask = document.createElement("div");
				mask.id = "mask";
				mask.style.height = 0;
				mask.innerHTML = "<p>X</p>";
				document.body.appendChild(mask);
				attachEventListener(mask, "click", toggleVisualisation, false);
			}
			
			var maskHeight = window.innerHeight;
			
			if (typeof maskHeight == "undefined")
			{
				maskHeight = document.body.clientHeight;
			}
			
			tween(mask, {height: maskHeight}, 600);
			
			setTimeout(
				function()
				{
					var canvas = document.createElement("canvas");
					canvas.id = "visuals";
					canvas.setAttribute("width", CANVAS_WIDTH);
					canvas.setAttribute("height", CANVAS_HEIGHT);
					document.body.appendChild(canvas);
	
					tick();
				},
				600
			);
		}
		else
		{
			alert("Sorry, your browser doesn't support wicked cool graphics. Please download one that supports wicked coolness.");
		}
	}
}




function clock()
{
	var monitor = document.getElementById("monitor");
	var ths = monitor.getElementsByTagName("th");
	
	for (var i = 0; i < ths.length; i++)
	{
		if (i == clockCount)
		{
			ths[i].className += " on";
		}
		else
		{
			ths[i].className = ths[i].className.replace(/(^| )on( |$)/g, " ");
		}
	}
	
	var samples = document.getElementById("samples");
	
	var trs = samples.getElementsByTagName("tr");
	
	for (var i = 0; i < trs.length; i++)
	{
		if (trs[i].getElementsByTagName("td")[clockCount].className.match(/(^| )on( |$)/))
		{
			if (canPlaySound)
			{
				playSound(trs[i].id);
			}
		}
	}
	
	clockCount++;
	
	if (clockCount > 11)
	{
		clockCount = 0;
	}
	
	clockTimer = setTimeout(clock, 60 * 1000 / BPM / 4);
}




function stopClock()
{
	if (typeof clockTimer != "undefined" && clockTimer != null)
	{
		clearTimeout(clockTimer);
	}
}




function toggleSample(event)
{
	var turnOn = false;
	

	
	if (this.className.match(/(^| )on( |$)/))
	{
		this.className = this.className.replace(/(^| )on( |$)/g, " ");
	}
	else
	{
		turnOn = true;
		this.className += " on";
	}

	if (event.type == "mousedown")
	{
		var self = this;
		
		function mousemoveToggle(event)
		{
			var target = event.target || event.srcElement;
			
			if (turnOn)
			{
				if (!target.className.match(/(^| )on( |$)/))
				{
					target.className += " on";
				}
			}
			else
			{
				target.className = target.className.replace(/(^| )on( |$)/g, " ");
			}
		}
		
		attachEventListener(document, "mousemove", mousemoveToggle, false);
		
		attachEventListener(
			document,
			"mouseup",
			function()
			{
				detachEventListener(document, "mousemove", mousemoveToggle, false);
			},
			false
		);
	}
	
	if (neverStarted)
	{
		togglePlay.apply(document.getElementById("play_drum"));
	}
	
	stopDefaultAction(event);
	return false;
}




function playSound (soundFile)
{

/*
	var sound = document["embed" + soundFile];
	
	if (sound == null)
	{
		var embedContainer = document.createElement("div");
		embedContainer.className = "embedContainer";
		document.body.appendChild(embedContainer);
		embedContainer.innerHTML = soundElementString(soundFile, sounds[soundFile]);

		sound = document["embed" + soundFile];
	}

	
	try
	{
		sound.Stop();
		sound.Rewind();
		sound.Play();
	}
	catch (error)
	{
		canPlaySound = false;
		alert("Looks like your browser can't play sound. If you really want to hear it, try downloading Quicktime.");
		
		alert("Error : " + error);
	}
	*/
	
	var audioElement;

	audioElement = new Audio("");
	
	// im DOM einfgen, sonst wird es nicht abgespielt
	document.body.appendChild(audioElement);
	
	// herausfinden welcher Medientyp abgespielt werden kann
	var canPlayType = audioElement.canPlayType("audio/ogg");
	if(canPlayType.match(/maybe|probably/i)) {
	canPlaySound = true;
	//alert("OK your browser can play sound.");	
	}
	else
	{
	canPlaySound = false;
	alert("Looks like your browser can't play sound.");	
	}
	

	
	


	var radius = 0;
	var circleColor = "#FF0000";
	
	switch(soundFile)
	{
		case "kick1":
			
			audioElementtemp1 = new Audio("");
			audioElementtemp1.src = 'sound/' + sounds.kick1.file;
			var volume_value = $('#slider1').slider("value") / 100;
            audioElementtemp1.volume = volume_value;
			audioElementtemp1.play();
	
			radius = 120;
			circleColor = "#FF0000";
			
			break;

		case "snare1":

			audioElementtemp2 = new Audio("");
			audioElementtemp2.src = 'sound/' + sounds.snare1.file;
			var volume_value = $('#slider2').slider("value") / 100;
            audioElementtemp2.volume = volume_value;
			audioElementtemp2.play();
		
			radius = 105;
			circleColor = "#FFCC00";
		
			break;
			
		case "work1":
	
			audioElementtemp8 = new Audio("");
			audioElementtemp8.src = 'sound/' + sounds.work1.file;
			var volume_value = $('#slider8').slider("value") / 100;
            audioElementtemp8.volume = volume_value;
			audioElementtemp8.play();
		
			radius = 90;
			circleColor = "#99FF00";
		
			break;

		case "clap1":
	
			audioElementtemp7 = new Audio("");
			audioElementtemp7.src = 'sound/' + sounds.clap1.file;
			var volume_value = $('#slider7').slider("value") / 100;
            audioElementtemp7.volume = volume_value;
			audioElementtemp7.play();
		
			radius = 75;
			circleColor = "#00FFCC";
			
			break;

		case "bongo1":
	
			audioElementtemp5 = new Audio("");
			audioElementtemp5.src = 'sound/' + sounds.bongo1.file;
			var volume_value = $('#slider5').slider("value") / 100;
            audioElementtemp5.volume = volume_value;
			audioElementtemp5.play();
		
			radius = 60;
			circleColor = "#00AAFF";
			
			break;

		case "bongo2":
	
			audioElementtemp6 = new Audio("");
			audioElementtemp6.src = 'sound/' + sounds.bongo2.file;
			var volume_value = $('#slider6').slider("value") / 100;
            audioElementtemp6.volume = volume_value;
			audioElementtemp6.play();
		
			radius = 45;
			circleColor = "#0000FF";
			
			break;

		case "hatOpen1":
	
			audioElementtemp3 = new Audio("");
			audioElementtemp3.src = 'sound/' + sounds.hatOpen1.file;
			var volume_value = $('#slider3').slider("value") / 100;
            audioElementtemp3.volume = volume_value;
			audioElementtemp3.play();
		
			radius = 30;
			circleColor = "#B65DFA";
			
			break;

		case "hatClose1":
		
			audioElementtemp4 = new Audio("");
			audioElementtemp4.src = 'sound/' + sounds.hatClose1.file;
			var volume_value = $('#slider4').slider("value") / 100;
            audioElementtemp4.volume = volume_value;
			audioElementtemp4.play();
	
			radius = 15;
			circleColor = "#F85DFA";
			
			break;
	}

	canvasDOM.push(
		{
			x: CANVAS_WIDTH / 2,
			y: CANVAS_HEIGHT / 2,
			size: radius,
			color: circleColor,
			creationTime: new Date().getTime()
		}
	);
	
	for (var i = 0; i < 15; i++)
	{
		var angle = Math.random() * Math.PI * 2;

		canvasDOM.push(
			{
				x: CANVAS_WIDTH / 2 + Math.sin(angle) * (Math.random() * 10 + radius + 10),
				y: CANVAS_HEIGHT / 2 + Math.cos(angle) * (Math.random() * 10 + radius + 10),
				size: Math.random() * 5 + 1,
				color: circleColor,
				creationTime: new Date().getTime()
			}
		);
	}
		
}




function soundElementString(soundName, soundFile)
{

/*
	if (typeof document.all != "undefined")
	{
		return '<object id="embed' + soundName +'" classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"codebase="http://www.apple.com/qtactivex/qtplugin.cab"><param name="src" value="' + soundFile.file + '"></param><param name="Autoplay" value="false"></param><embed name="embed' + soundName +'" src="' + soundFile.file + '" autostart="false" enablejavascript="true" /></object>';
	}
	else
	{
		return '<object id="embed' + soundName +'" classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"codebase="http://www.apple.com/qtactivex/qtplugin.cab"><param name="src" value="' + soundFile.data + '"></param><param name="Autoplay" value="false"></param><embed name="embed' + soundName +'" src="' + soundFile.data + '" autostart="false" enablejavascript="true" /></object>';
	}
	
	*/
}




function tick()
{
	var FPS = 25;
	var FADE_TIME = 800;
	var canvas = document.getElementById("visuals");
	var currTime = new Date().getTime();
	
	if (typeof canvas.getContext != "undefined")
	{
		var context = canvas.getContext("2d");
		context.clearRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);
		
		for (var i = 0; i < canvasDOM.length; i++)
		{
			var scaling = (FADE_TIME - (currTime - canvasDOM[i].creationTime)) / FADE_TIME;
			
			if (scaling > 0)
			{
				context.beginPath();
				context.moveTo(canvasDOM[i].x, canvasDOM[i].y);
				context.arc(canvasDOM[i].x, canvasDOM[i].y, canvasDOM[i].size * scaling, 0, Math.PI * 2, true);
				context.fillStyle = canvasDOM[i].color;
				context.fill();
			}
			else
			{
				canvasDOM.splice(i, 1);
				
				i--;
			}
		}
	
		tickTimer = setTimeout(tick, 1000 / FPS);
	}
	else
	{
		alert("Sorry, your browser doesn't support wicked cool graphics. Please download one that supports wicked coolness.");
		
		toggleVisualisation();
	}
}




function stopTick()
{
	if (typeof tickTimer != "undefined" && tickTimer != null)
	{
		clearTimeout(tickTimer);
	}
}




function addLoadListener(fn)
{
	if (typeof window.addEventListener != 'undefined')
	{
		window.addEventListener('load', fn, false);
	}
	else if (typeof document.addEventListener != 'undefined')
	{
		document.addEventListener('load', fn, false);
	}
	else if (typeof window.attachEvent != 'undefined')
	{
		window.attachEvent('onload', fn);
	}
	else
	{
		return false;
	}
}




function attachEventListener(target, eventType, functionRef, capture)
{
	if (typeof target.addEventListener != "undefined")
	{
		target.addEventListener(eventType, functionRef, capture);
	}
	else if (typeof target.attachEvent != "undefined")
	{
		var functionString = eventType + functionRef;
		target["e" + functionString] = functionRef;
        
		target[functionString] = function(event)
		{
			if(typeof event == "undefined")
			{
				event = window.event
			};

			target["e" + functionString](event);
        };
        
		target.attachEvent("on" + eventType, target[functionString]);
	}
}




function detachEventListener(target, eventType, functionRef, capture)
{
	if (typeof target.removeEventListener != "undefined")
	{
		target.removeEventListener(eventType, functionRef,
			capture)
	}
	else if (typeof target.detachEvent != "undefined")
	{
		var functionString = eventType + functionRef;

		target.detachEvent("on" + eventType, 
			target[functionString]);

		target["e" + functionString] = null;
		target[functionString] = null;

	}
	else
	{
		target["on" + eventType] = null;
	}

	return true;
}




function stopDefaultAction(event)
{
	event.returnValue = false;
	
	if (typeof event.preventDefault != "undefined")
	{
		event.preventDefault();
	}
}




function tween(target, parameters, duration, startTime)
{
	var FPS = 25;

	if (typeof duration == "undefined")
	{
		duration: 1000;
	}
	
	if (typeof startTime == "undefined")
	{
		startTime = new Date().getTime();
	}

	var currTime = new Date().getTime();
	var remainingSteps = (startTime + duration - currTime) / (1000 / FPS);
	
	for (var parameter in parameters)
	{
		var curr = parseInt(retrieveComputedStyle(target, parameter));
		
		if (isNaN(curr))
		{
			curr = 0;
		}
		
		switch (parameter)
		{
			case "color":
			
				curr = retrieveComputedStyle(target, parameter);
				var currRGB = getRGB(curr);
				var targetRGB = getRGB(parameters[parameter]);

				target.style[parameter] = "rgb(" + Math.round(currRGB.red + ((targetRGB.red - currRGB.red) * 1 / remainingSteps)) + "," + Math.round(currRGB.green + ((targetRGB.green - currRGB.green) * 1 / remainingSteps)) + "," + Math.round(currRGB.blue + ((targetRGB.blue - currRGB.blue) * 1 / remainingSteps)) + ")";
				
				break;
				
			case "fontSize":
			
				curr = retrieveComputedStyle(target, parameter);
				
				if (curr.match(/em$/))
				{
					curr = parseFloat(curr) * getEMSize(target);
				}
				else
				{
					curr = parseFloat(curr);
				}
				
				if (typeof parameters[parameter] == "string" && parameters[parameter].match(/em$/))
				{
					parameters[parameter] = parseFloat(parameters[parameter]) * getEMSize(target);
				}
			
			default:

				target.style[parameter] = curr + ((parseFloat(parameters[parameter]) - curr) * 1 / remainingSteps) + "px";
		}
	}
	
	if (remainingSteps > 0)
	{
		setTimeout(function()
			{
				tween(target, parameters, duration, startTime);
			},
			1000 / FPS
		);
	}
	else
	{
		for (var parameter in parameters)
		{
			target.style[parameter] = parameters[parameter]
		}
	}
}




function retrieveComputedStyle(element, styleProperty)
{
  var computedStyle = null;

  if (typeof element.currentStyle != "undefined")
  {
    computedStyle = element.currentStyle;
  }
  else
  {
    computedStyle = document.defaultView.getComputedStyle(element, null);
  }

  return computedStyle[styleProperty];
}